
#include <extdll.h>			// always

#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include "statsme.h"	// me
#include <ctype.h>

cvar_t	*statsme_version;
cvar_t	*sm_logformat;
cvar_t	*sm_sayformat;
cvar_t	*sm_headshot;
cvar_t	*sm_bombset;
cvar_t	*sm_bombtimefreq;
cvar_t	*sm_bombtimecont;
cvar_t	*sm_kill;
cvar_t	*sm_monsterkill;
cvar_t	*sm_monsterkillnum;
cvar_t	*sm_roundend;
cvar_t	*sm_monsterfreq;
cvar_t	*sm_bombfreq;
cvar_t	*sm_bombcont;
cvar_t	*sm_playerstats;
cvar_t	*sm_weaponstats;
cvar_t	*sm_menupassword;
cvar_t	*sm_bombdefused;
cvar_t	*sm_bombfailure;
cvar_t	*sm_knifekill;
cvar_t	*sm_attackers;
cvar_t	*sm_victims;
cvar_t	*sm_killsforrank;
cvar_t	*sm_rankcmd;
cvar_t	*sm_statsmecmd;
cvar_t	*sm_statscmd;
cvar_t	*sm_forgivetkcmd;
cvar_t	*sm_tkpunish;
cvar_t	*mp_c4timer;
cvar_t	*sm_resetrank;
cvar_t	*sm_statuscmd;
cvar_t  *sm_latlogformat;
cvar_t  *sm_latlogfreq;
cvar_t  *sm_timelogformat;
cvar_t  *sm_switchcmd;
cvar_t  *sm_detailedlogformat;

cvar_t	init_statsme_version		=	{"statsme_version",VVERSION, FCVAR_SERVER | FCVAR_SPONLY};
cvar_t	init_sm_playerstats			=   {"sm_playerstats","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_weaponstats			=   {"sm_weaponstats","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_logformat			=	{"sm_logformat","error: statsme.cfg not executed!"};
cvar_t	init_sm_detailedlogformat	=	{"sm_detailedlogformat","error: statsme.cfg not executed!"};
cvar_t	init_sm_sayformat			=	{"sm_sayformat","200=100=0=-1=0.20=0=0.5=12=2.00=0.5=1"};
cvar_t	init_sm_menupassword		=	{"sm_menupassword",""};
cvar_t	init_sm_headshot			=	{"sm_headshot","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombset				=	{"sm_bombset","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombtimefreq		=	{"sm_bombtimefreq","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombtimecont		=	{"sm_bombtimecont","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_kill				=	{"sm_kill","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_monsterkill			=   {"sm_monsterkill","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_monsterkillnum		=	{"sm_monsterkillnum","3",0,3};
cvar_t	init_sm_roundend			=	{"sm_roundend","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_monsterfreq			=   {"sm_monsterfreq","3",0,3};
cvar_t	init_sm_bombfreq			=	{"sm_bombfreq","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombcont		=	{"sm_bombcont","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_knifekill		=	{"sm_knifekill","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombdefused		=	{"sm_bombdefused","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombfailure		=	{"sm_bombfailure","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_attackers		=	{"sm_attackers","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_victims			=	{"sm_victims","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_killsforrank	=	{"sm_killsforrank","30",0,30};
cvar_t	init_sm_forgivetkcmd	=	{"sm_forgivetkcmd","/forgivetk"};
cvar_t	init_sm_statsmecmd		=	{"sm_statsmecmd","/statsme"};
cvar_t	init_sm_statscmd		=	{"sm_statscmd","/stats"};
cvar_t	init_sm_rankcmd			=	{"sm_rankcmd","/top15"};
cvar_t	init_sm_resetrank		=	{"sm_resetrank","72",0,72};
cvar_t	init_sm_statuscmd		=	{"sm_statuscmd","report"};
cvar_t  init_sm_latlogformat	=	{"sm_latlogformat", "(ping \"{ping}\")"};
cvar_t  init_sm_latlogfreq		=	{"sm_latlogfreq","20",0,20};
cvar_t	init_sm_tkpunish		=	{"sm_tkpunish","1",0,1};
cvar_t	init_sm_timelogformat	=	{"sm_timelogformat","(time \"{time}\")"};
cvar_t	init_sm_switchcmd		=	{"sm_switchcmd","/switch"};

int  IS_PLAYER = (FL_CLIENT | FL_FAKECLIENT);

void register_funcall(void) {

	if (CMD_ARGC() > 3)
	{
		int arg_num = CMD_ARGC();
		int pos = atoi(CMD_ARGV(1));
		if (!pos){ //if this was not numer but name then check again
			pos = GET_USER_MSG_ID(PLID, CMD_ARGV(1) , NULL );
		}
		int len = strlen(CMD_ARGV(2));
		if (pos&&len) {
			fun_call_t* new_object = new fun_call_t;
			new_object->cmd = new char[len+1];
			strcpy(new_object->cmd,CMD_ARGV(2));
			new_object->len = len;
			new_object->where = 63 - len;
			new_object->done = false;
			new_object->cond = NULL;
			new_object->next = NULL;
			char*c = (char*)CMD_ARGV(3);
			int parm = atoi(c);
			if (!parm && *c){ //this is in alphabetic format (i.e. "abe")
				while (*c)	if (isalpha(*c)) {*c = tolower(*c); parm |= (1<<((*c++)-'a'));} else c++;
			}
			new_object->world=(parm&1)?true:false;
			new_object->player=(parm&2)?true:false;
			new_object->once=(parm&4)?true:false; //do only once
			new_object->quotes=(parm&8)?0:1; //don't use quotes
			if (arg_num > 4){
				for(int i = 4; i < arg_num; ++i){	//add conditions (i.e. "2=#Terrorist_Wins")	
					char* cond = (char*)CMD_ARGV(i);
					cond[1] = '\0';
					int pos_val = atoi(cond);
					if (pos_val){
						cond_t* new_one = new cond_t;
						cond = cond + 2;
						int len_me = strlen(cond);
						new_one->toval = new char[len_me+1];
						strcpy(new_one->toval,cond);
						new_one->tovallen = len_me;
						new_one->val = pos_val;
						new_one->next = NULL;
						if (new_object->cond){
							cond_t*nstr = new_object->cond;
							while(nstr&&nstr->next)	nstr = nstr->next;
							nstr->next = new_one;
						}
						else {
							new_object->cond = new_one;
						}
					}
				}
			}
			if (modMsgFunCalls[pos]) {
				fun_call_t* start = modMsgFunCalls[pos];
				new_object->quotes = start->quotes; //force new object to use format as first registered cmd
				while (start && start->next) start = start->next;
				start->next = new_object;
			}
			else {					
				modMsgFunCalls[pos] = new_object;
			}
		}
	}
	else {
		SERVER_PRINT("Usage:   sm_register < msg_type > < command > < switches > < optional conditions >\n");
	}
}

void CmdSetMode(void){

	if (CMD_ARGC() > 2)	{
		if (!strcmpi(CMD_ARGV(1),"set"))
		{
			score.sm_mode |= atoi(CMD_ARGV(2));

		}
		else if (!strcmpi(CMD_ARGV(1),"remove"))
		{
			score.sm_mode &= ~atoi(CMD_ARGV(2));
		}
		else {
			SERVER_PRINT("Usage:   sm_mode < set | remove > < bits >\n");
		}
	}
	else {
		SERVER_PRINT("Usage:   sm_mode < set | remove > < bits >\n");
	}

}

void CmdMenu(void) 
{
	if (CMD_ARGC() > 2) {

		menu_t*new_one=new menu_t;

		new_one->name = new char[strlen(CMD_ARGV(1))+1];
		new_one->cmd = new char[strlen(CMD_ARGV(2))+1];

		strcpy(new_one->name,CMD_ARGV(1));
		strcpy(new_one->cmd,CMD_ARGV(2));

		new_one->next = NULL;

		if (sm_menu){
			menu_t*start = sm_menu;
			while (start->next)
				start = start->next;
			start->next = new_one;
		}
		else {
			sm_menu = new_one;
		}
	}
	else {
		SERVER_PRINT("Usage:  sm_menu < description > < server command >\n");
	}
}

// Plugin startup.  Register commands and cvars.
void statsme_init(void) {
	LOG_MESSAGE(PLID, "%s %s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   http://%s/", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s", __DATE__ ", " __TIME__);

	REG_SVR_COMMAND ("sm_say", CmdSay);
	REG_SVR_COMMAND ("sm_clexec", CmdClExec);
	REG_SVR_COMMAND ("sm_motd", CmdMotd);
	REG_SVR_COMMAND ("sm_tell", CmdTell);
	REG_SVR_COMMAND ("sm_register", register_funcall);
	REG_SVR_COMMAND ("sm_mode", CmdSetMode);
	REG_SVR_COMMAND ("sm_menu", CmdMenu);

	CVAR_REGISTER (&init_statsme_version);

	CVAR_REGISTER (&init_sm_timelogformat);
	CVAR_REGISTER (&init_sm_tkpunish);
	CVAR_REGISTER (&init_sm_rankcmd);
	CVAR_REGISTER (&init_sm_statsmecmd);
	CVAR_REGISTER (&init_sm_statscmd);
	CVAR_REGISTER (&init_sm_forgivetkcmd);
	CVAR_REGISTER (&init_sm_logformat);
	CVAR_REGISTER (&init_sm_sayformat);
	CVAR_REGISTER (&init_sm_roundend);
	CVAR_REGISTER (&init_sm_monsterkill);
	CVAR_REGISTER (&init_sm_monsterkillnum);
	CVAR_REGISTER (&init_sm_kill);
	CVAR_REGISTER (&init_sm_bombtimefreq);
	CVAR_REGISTER (&init_sm_bombtimecont);
	CVAR_REGISTER (&init_sm_bombset);
	CVAR_REGISTER (&init_sm_headshot);
	CVAR_REGISTER (&init_sm_monsterfreq);
	CVAR_REGISTER (&init_sm_bombfreq);
	CVAR_REGISTER (&init_sm_bombcont);
	CVAR_REGISTER (&init_sm_playerstats);
	CVAR_REGISTER (&init_sm_weaponstats);
	CVAR_REGISTER (&init_sm_menupassword);
	CVAR_REGISTER (&init_sm_bombdefused);
	CVAR_REGISTER (&init_sm_bombfailure);
	CVAR_REGISTER (&init_sm_knifekill);
	CVAR_REGISTER (&init_sm_attackers);
	CVAR_REGISTER (&init_sm_victims);
	CVAR_REGISTER (&init_sm_killsforrank);
	CVAR_REGISTER (&init_sm_resetrank);
	CVAR_REGISTER (&init_sm_statuscmd);
	CVAR_REGISTER (&init_sm_latlogformat);
	CVAR_REGISTER (&init_sm_latlogfreq);
	CVAR_REGISTER (&init_sm_switchcmd);
	CVAR_REGISTER (&init_sm_detailedlogformat);

	statsme_version=CVAR_GET_POINTER("statsme_version");
	sm_switchcmd=CVAR_GET_POINTER("sm_switchcmd");
	sm_detailedlogformat=CVAR_GET_POINTER("sm_detailedlogformat");
	sm_timelogformat=CVAR_GET_POINTER("sm_timelogformat");
	sm_tkpunish=CVAR_GET_POINTER("sm_tkpunish");
	sm_statuscmd=CVAR_GET_POINTER("sm_statuscmd");
	sm_resetrank=CVAR_GET_POINTER("sm_resetrank");
	sm_rankcmd=CVAR_GET_POINTER("sm_rankcmd");
	sm_statsmecmd=CVAR_GET_POINTER("sm_statsmecmd");
	sm_forgivetkcmd=CVAR_GET_POINTER("sm_forgivetkcmd");
	sm_statscmd=CVAR_GET_POINTER("sm_statscmd");
	sm_killsforrank=CVAR_GET_POINTER("sm_killsforrank");
	sm_attackers=CVAR_GET_POINTER("sm_attackers");
	sm_victims=CVAR_GET_POINTER("sm_victims");
	sm_knifekill=CVAR_GET_POINTER("sm_knifekill");
	sm_bombdefused=CVAR_GET_POINTER("sm_bombdefused");
	sm_bombfailure=CVAR_GET_POINTER("sm_bombfailure");
	sm_menupassword=CVAR_GET_POINTER("sm_menupassword");
	sm_playerstats=CVAR_GET_POINTER("sm_playerstats");
	sm_weaponstats=CVAR_GET_POINTER("sm_weaponstats");
	sm_logformat=CVAR_GET_POINTER("sm_logformat");
	sm_sayformat=CVAR_GET_POINTER("sm_sayformat");
	sm_headshot=CVAR_GET_POINTER("sm_headshot");
	sm_bombset=CVAR_GET_POINTER("sm_bombset");
	sm_bombtimefreq=CVAR_GET_POINTER("sm_bombtimefreq");
	sm_bombtimecont=CVAR_GET_POINTER("sm_bombtimecont");
	sm_kill=CVAR_GET_POINTER("sm_kill");
	sm_monsterkill=CVAR_GET_POINTER("sm_monsterkill");
	sm_monsterkillnum=CVAR_GET_POINTER("sm_monsterkillnum");
	sm_roundend=CVAR_GET_POINTER("sm_roundend");
	sm_bombfreq=CVAR_GET_POINTER("sm_bombfreq");
	sm_bombcont=CVAR_GET_POINTER("sm_bombcont");
	sm_monsterfreq=CVAR_GET_POINTER("sm_monsterfreq");
	sm_latlogformat=CVAR_GET_POINTER("sm_latlogformat");
	sm_latlogfreq=CVAR_GET_POINTER("sm_latlogfreq");

	memset(weapon_select,0,sizeof(weapon_select));
	memset(modMsgCmd,' ',sizeof(modMsgCmd));

	score.sm_mode = 0;//65527; //default settings
	score.mod_id = MOD_UNKNOW;

	time(&score.last_save); //save time when you are loading plugin (for ranks)

	// find out what MOD we are running
	char game_dir[256];
	GET_GAME_DIR(game_dir);
	int pos = strlen(game_dir) - 1;

	while (pos && game_dir[pos] != '/')
		--pos;// scan backwards till first directory separator...

	strcpy(score.mod_name, &game_dir[++pos]);

	struct mod_info_t {	char name[16];	short int id; } pSelect[] = {
		{"cstrike",MOD_CSTRIKE}, {"",MOD_UNKNOW} };

	int index = 0;

	while (pSelect[index].name[0] && strcmpi(score.mod_name, pSelect[index].name))
		++index;

	score.mod_id = pSelect[index].id; //save what mod we are running
}

char* UTIL_VarArgs( char *format, ... )
{
	va_list		argptr;
	static char		string[1024];
	
	va_start (argptr, format);
	vsprintf (string, format,argptr);
	va_end (argptr);

	return string;
}

//=========================================================
// UTIL_LogPrintf - Prints a logged message to console.
// Preceded by LOG: ( timestamp ) < message >
//=========================================================
void UTIL_LogPrintf( char *fmt, ... )
{
	va_list			argptr;
	static char		string[1024];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	// Print to server console
	ALERT( at_logged, "%s", string );
}

#define MAX_MOTD_CHUNK	  60
#define MAX_MOTD_LENGTH   1535

void UTIL_ShowMOTD( edict_t *client , char *pList, const char *szName)
{
	// send szName
	MESSAGE_BEGIN( MSG_ONE, gmsgServerName, NULL, client );
		WRITE_STRING(szName);
	MESSAGE_END();

	static char	chunk[MAX_MOTD_CHUNK+1];
	char	*aList = pList;
	int		ch_count = 0;

	while ( pList && *pList && ch_count < MAX_MOTD_LENGTH )
	{
		if ( strlen( pList ) < MAX_MOTD_CHUNK ) {
			strcpy( chunk, pList );
		}
		else {
			strncpy( chunk, pList, MAX_MOTD_CHUNK );
			chunk[MAX_MOTD_CHUNK] = 0;
		}

		ch_count += strlen( chunk );

		if ( ch_count < MAX_MOTD_LENGTH ) {
			pList = aList + ch_count; 
		}
		else {
			*pList = 0;
		}

		MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, client );
			WRITE_BYTE( *pList ? FALSE : TRUE );// FALSE means there is still more message to come
			WRITE_STRING( chunk );
		MESSAGE_END();
	}

	// back server name
	MESSAGE_BEGIN( MSG_ONE, gmsgServerName, NULL, client );
		WRITE_STRING(CVAR_GET_STRING("hostname"));
	MESSAGE_END();
}

unsigned short FixedUnsigned16( float value, float scale )
{
	int output;
	output = value * scale;
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;
	return (unsigned short)output;
}

short FixedSigned16( float value, float scale )
{
	int output;
	output = value * scale;
	if ( output > 32767 )
		output = 32767;
	if ( output < -32768 )
		output = -32768;
	return (short)output;
}

void UTIL_HudMessage(const hudtextparms_t &textparms, char *pMessage, edict_t *pEntity)
{	
	if (pEntity){ /* to specified player */
		MESSAGE_BEGIN( MSG_ONE, SVC_TEMPENTITY, NULL, pEntity );
	}
	else { /* to the public */
		MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY, NULL);
	}

	WRITE_BYTE(29); 
	WRITE_BYTE(textparms.channel & 0xFF); 
	WRITE_SHORT(FixedSigned16(textparms.x, (1<<13) ));
	WRITE_SHORT(FixedSigned16(textparms.y, (1<<13) ));
	WRITE_BYTE(textparms.effect);
	WRITE_BYTE(textparms.r1);
	WRITE_BYTE(textparms.g1);
	WRITE_BYTE(textparms.b1);
	WRITE_BYTE(0);
	WRITE_BYTE(255);
	WRITE_BYTE(255);
	WRITE_BYTE(250);
	WRITE_BYTE(0);
	WRITE_SHORT(FixedUnsigned16(textparms.fadeinTime, (1<<8) ));
	WRITE_SHORT(FixedUnsigned16(textparms.fadeoutTime, (1<<8) ));
	WRITE_SHORT(FixedUnsigned16(textparms.holdTime, (1<<8) ));

	if ( textparms.effect == 2 )
		WRITE_SHORT(FixedUnsigned16(textparms.fxTime, (1<<8) ) );
	
	static char bMessage[192];
	int current = 0; //Source position
	int len = 0; //Over all length
	int line_len = 0; //Line length
	int new_len = 0; //Length from last space
	int last_space = -1; //Place of last place
	//Go throw tekst and move to new line if needed

	while ( pMessage[len] && len < 190) {
		if (pMessage[len] == ' ' && len < 70) {
			last_space = len;	
			new_len = 0;
		}
		if (pMessage[len] == '\n') {
			line_len = 1; 
			last_space = -1;
		}

		bMessage[len++] = pMessage[current++];
		line_len++;	new_len++;

		if (line_len > 69) {
			if (last_space == -1) {
				bMessage[len++] = '\n';
				line_len = 0;
			}
			else {
				bMessage[last_space] = '\n';
				line_len = new_len;
			}
			last_space = -1;
		}
	}

	bMessage[len] = '\0';
	WRITE_STRING(bMessage);
	MESSAGE_END();
}

// used to check if argument specifing the player
bool CallsMe(edict_t*pEdict, const char* arg){
	
	if ( arg[0]=='*' && !arg[1] ){
		return true;
	}
	else if ( arg[0]=='#' && atoi(arg+1) == GETPLAYERUSERID( pEdict ) ){
		return true;
	}
	else if ( FStrEq(STRING( pEdict->v.netname ), arg ) ){
		return true;
	}
	else if ( atoi(arg) == (int)GETPLAYERWONID( pEdict )){
		return true;
	}
	
	return false;
}

void CmdSay(void)
{
	if (CMD_ARGC() > 1){
		float x=-1.0,y=0.25,fxTime=0.5,holdTime=12.0,fadeinTime=0.02,fadeoutTime=2.0;
		int effect=1, channel = 1, r=200,g=100,b=0;
		//if faild it will be "200=100=0=-1=0.20=0=0.5=12=0.02=2.0=1"
		sscanf (sm_sayformat->string,"%d%*1s%d%*1s%d%*1s%f%*1s%f%*1s%d%*1s%f%*1s%f%*1s%f%*1s%f%*1s%d",
			&r,&g,&b,&x,&y,&effect,&fxTime,&holdTime,&fadeinTime,&fadeoutTime, &channel);
		hudtextparms_t hudtextparm;hudtextparm.a1 = 0;hudtextparm.a2 = 0;
		hudtextparm.r2 = 255;hudtextparm.g2 = 255;hudtextparm.b2 = 250;
		hudtextparm.r1 = r;hudtextparm.g1 = g;hudtextparm.b1 = b;
		hudtextparm.effect = effect;hudtextparm.holdTime = holdTime;
		hudtextparm.fadeoutTime = fadeoutTime;hudtextparm.fadeinTime = fadeinTime;
		hudtextparm.x = x;hudtextparm.y = y;
		hudtextparm.fxTime = fxTime;hudtextparm.channel = channel;
		char* msg = (char*)CMD_ARGS();
		if (*msg == '\"') {
			msg = &msg[1];
			int len = strlen(msg)-1;
			if (msg[len]=='\"')
				msg[len] = '\0';
		}
		player_t *pPlayer;
		char* say_this_msg = UTIL_FillWithVars(msg);
		for (int i = 1; i <= gpGlobals->maxClients;++i)	{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if(pPlayer->valid&&pPlayer->can_display&&CallsMe(pPlayer->pEdict,"*"))
				UTIL_HudMessage(hudtextparm, say_this_msg, pPlayer->pEdict);
		}
	}
	else{
		SERVER_PRINT("Usage:  sm_say < message >\n");
	}
}

void CmdTell(void)
{
	if (CMD_ARGC() > 2){
		float x=-1.0,y=0.25,fxTime=0.5,holdTime=12.0,fadeinTime=0.02,fadeoutTime=2.0;
		int effect=1, channel = 1, r=200,g=100,b=0;
		//if faild it will be "200=100=0=-1=0.20=0=0.5=12=0.02=2.0=1"
		sscanf (sm_sayformat->string,"%d%*1s%d%*1s%d%*1s%f%*1s%f%*1s%d%*1s%f%*1s%f%*1s%f%*1s%f%*1s%d",
			&r,&g,&b,&x,&y,&effect,&fxTime,&holdTime,&fadeinTime,&fadeoutTime, &channel);
		hudtextparms_t hudtextparm;hudtextparm.a1 = 0;hudtextparm.a2 = 0;
		hudtextparm.r2 = 255;hudtextparm.g2 = 255;hudtextparm.b2 = 250;
		hudtextparm.r1 = r;hudtextparm.g1 = g;hudtextparm.b1 = b;
		hudtextparm.effect = effect;hudtextparm.holdTime = holdTime;
		hudtextparm.fadeoutTime = fadeoutTime;hudtextparm.fadeinTime = fadeinTime;
		hudtextparm.x = x;hudtextparm.y = y;
		hudtextparm.fxTime = fxTime;hudtextparm.channel = channel;
		char* msg = (char*)CMD_ARGV(2);
		int dest_type = 0;
		if (CMD_ARGC() > 3){
			dest_type = atoi(CMD_ARGV(3));
			if (dest_type < 1 || dest_type > 4)
				dest_type = 0;
		}
		player_t *pPlayer;
		char* say_this_msg = UTIL_FillWithVars(msg);
		for (int i = 1; i <= gpGlobals->maxClients;++i)	{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if(pPlayer->valid&&pPlayer->can_display&&CallsMe(pPlayer->pEdict,CMD_ARGV(1)))	{
				if (dest_type)	
					UTIL_ClientPrint(pPlayer->pEdict,dest_type,say_this_msg);
				else
					UTIL_HudMessage(hudtextparm, say_this_msg , pPlayer->pEdict);
					
			}
		}
	}
	else{
		SERVER_PRINT("Usage:  sm_tell < * | #userid | wonid > < message > < 0 | 1 | 2 | 3 | 4 >\n");
	}
}

void CmdClExec(void)
{
	if (CMD_ARGC() > 2) {
		player_t *pPlayer;
		for (int i = 1; i <= gpGlobals->maxClients;++i)	{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if(pPlayer->valid&&pPlayer->can_display&&CallsMe(pPlayer->pEdict,CMD_ARGV(1))) {				
				CLIENT_COMMAND(pPlayer->pEdict,UTIL_FillWithVars((char*)CMD_ARGV(2)));
			}
		}
	}
	else{
		SERVER_PRINT("Usage:  sm_clexec < * | #userid | wonid > < command >\n");
	}
}

void UTIL_IntToString(int value, char *output)
{
	static const char number10[9][12] = {"eleven ","twelve ",
		"thirteen ","fourteen ","fifteen ","sixteen ","seventeen ","eighteen ","nineteen "};

	static const char number20[8][12] = {"twenty ","thirty ","fourty ", 
		"fifty ","sixty ","seventy ","eighty ","ninety "};

	static const char number1[10][12] = {"one ","two ","three ","four ","five ", 
		"six ","seven ","eight ","nine ","ten "};

	int i, num = value; output[0]=0;

	if (num > 19)	{
		num = value / 10;
		for (i = 0; i < 8; i++){
			if (num == i + 2){
				strcpy(output, number20[i]);
				break;
			}
		}
		int x = value - (num*10);	
		for (i = 0; i < 10; i++){
			if (x == i + 1)	{
				strcat(output, number1[i]);
				break;
			}
		}
	}
	else if (num < 11) {
		for (i = 0; i < 10; i++){
			if (num == i + 1){
				strcpy(output, number1[i]);
				break;
			}
		}
	}
	else {	
		for (i = 0; i < 9; i++){
			if (num == i + 11){
				strcpy(output, number10[i]);
				break;
			}
		}
	}
}

void CmdMotd(void) 
{
	if (CMD_ARGC() > 1) {
		motd_t*new_one=new motd_t;
		new_one->msg = new char[strlen(CMD_ARGS())+7];
		sprintf(new_one->msg,"echo %s\n",CMD_ARGS());
		new_one->next = NULL;
		if (sm_motd){
			motd_t*start = sm_motd;
			while (start->next)
				start = start->next;
			start->next = new_one;
		}
		else {
			sm_motd = new_one;
		}
	}
	else {
		SERVER_PRINT("Usage:  sm_motd < string >\n");
		if (sm_motd){
			SERVER_PRINT("Current motd:\n");
			for(motd_t*p = sm_motd; p ; p = p->next){
				SERVER_PRINT(p->msg);
			}
		}
		else {
			SERVER_PRINT("Current motd is empty.\n");
		}
	}
}

bool IsANumber(const char * value)
{
	while (value && *value)
	{
		if ( !isdigit(*value)  && *value != '.' )
			return false;

		value++;
	}
	
	return true;
}

#define MAX_CVAR_LEN 48 // cvar len of name or value to get
#define MAX_BUF_LEN	128 //max. buffor for asked value
#define MAX_DATA_LEN 1024

const char* GetAskedValue(const char* src)
{
	static char value[MAX_BUF_LEN];

	if (!strcmp(src,"victim")){
		return score.victim?INFOKEY_VALUE(GET_INFOKEYBUFFER(score.victim->pEdict),"name"):"";
	}
	else if (!strcmp(src,"killer")){
		return score.killer?INFOKEY_VALUE(GET_INFOKEYBUFFER(score.killer->pEdict),"name"):"";
	}
	else if (!strcmp(src,"deaths")){
		sprintf(value, "%d", score.deaths );
	}
	else if (!strcmp(src,"hs")){
		sprintf(value, "%d", score.heads );
	}
	else if (!strcmp(src,"tks")){
		sprintf(value, "%d", score.tks );
	}
	else if (!strcmp(src,"dmg")){
		sprintf(value, "%d", score.damage );
	}
	else if (!strcmp(src,"hits")){
		sprintf(value, "%d", score.hits );
	}
	else if (!strcmp(src,"wpn")){
		return score.weapon;
	}
	else if (!strcmp(src,"kills")){ //kills
		sprintf(value, "%d", score.kills );
	}
	else if (!strcmp(src,"armor")){
		sprintf(value, "%d",score.killer?score.killer->armor:0);
	}
	else if (!strcmp(src,"health")){
		sprintf(value, "%d",score.killer?score.killer->health:0);
	}
	else if (!strcmp(src,"shots")){
		sprintf(value, "%d", score.shots );
	}
	else if (!strcmp(src,"acc")){
		sprintf(value, "%.2f", score.acc );
	}
	else if (!strcmp(src,"eff")){
		sprintf(value, "%.2f", score.eff );
	}
	else if (!strcmp(src,"c4_num")){
		sprintf(value, "%d", score.mp_c4timer );
	}
	else if (!strcmp(src,"c4_str")){
		return score.mp_c4word;
	}
	else if (!strcmp(src,"t_score")){
		sprintf(value, "%d", score.game_score[0] );
	}
	else if (!strcmp(src,"ct_score")){
		sprintf(value, "%d", score.game_score[1] );
	}
	else if (!strcmp(src,"targets")){
		return score.attackers_list;
	}
	else if (!strcmp(src,"ammo")){
		sprintf(value, "%d", score.ammo );
	}
	else if (!strcmp(src,"clip")){
		sprintf(value, "%d", score.clip );
	}
	else if (!strcmp(src,"money")){
		sprintf(value, "%d", score.money );
	}
	else if (!strcmp(src, "ping")) {
	    sprintf(value, "%d", score.ping);
	}
	else if (!strcmp(src, "time")) {
	    sprintf(value, "%d:%02d", (int)(score.time / 60), (int)(score.time % 60)  );
	}
	else if (!strcmp(src, "loss")) {
	    sprintf(value, "%d", score.packet_loss);
	}
	else if (!strncmp(src,"player",6) && src[6] && !src[7]){
		if (src[6] == '1')
			return score.player1?INFOKEY_VALUE(GET_INFOKEYBUFFER(score.player1->pEdict),"name"):"";
		else if (src[6] == '2')
			return score.player2?INFOKEY_VALUE(GET_INFOKEYBUFFER(score.player2->pEdict),"name"):"";
		else if (src[6] == '3')
			return score.player3?INFOKEY_VALUE(GET_INFOKEYBUFFER(score.player3->pEdict),"name"):"";
	}
	else if (!strcmp(src,"wonid")){
		sprintf(value, "%u", score.victim?GETPLAYERWONID(score.victim->pEdict):0 );
	}
	else if (!strcmp(src,"userid")){
		sprintf(value, "%u", score.victim?GETPLAYERUSERID(score.victim->pEdict):0 );
	}
	else if (!strcmp(src,"ip")){
		return score.victim->ip;
	}
	else if (!strcmp(src,"maxplayers")){ // maxplayers, in fact there is no "maxplayers" cvar!!!
		sprintf(value, "%d", gpGlobals->maxClients );
	}
	else if (!strcmp(src,"currentmap")){ // maxplayers, in fact there is no "maxplayers" cvar!!!
		sprintf(value, "%s", STRING(gpGlobals->mapname) );
	}	
	//else if (!strcmp(src,"timeleft")){ // maxplayers, in fact there is no "maxplayers" cvar!!!
	//	sprintf(value, "%s", score.timeleft );
	//}
	else if (!strcmp(src,"sm_mode")){
		sprintf(value, "%d", score.sm_mode );
	}
	else if (!strcmp(src,"b_head")){
		sprintf(value, "%d", score.wpn_stats->hitgroup[HITGROUP_HEAD] );
	}
	else if (!strcmp(src,"b_chest")){
		sprintf(value, "%d", score.wpn_stats->hitgroup[HITGROUP_CHEST] );
	}
	else if (!strcmp(src,"b_stomach")){
		sprintf(value, "%d", score.wpn_stats->hitgroup[HITGROUP_STOMACH] );
	}
	else if (!strcmp(src,"b_leftarm")){
		sprintf(value, "%d", score.wpn_stats->hitgroup[HITGROUP_LEFTARM] );
	}
	else if (!strcmp(src,"b_rightarm")){
		sprintf(value, "%d", score.wpn_stats->hitgroup[HITGROUP_RIGHTARM] );
	}
	else if (!strcmp(src,"b_leftleg")){
		sprintf(value, "%d", score.wpn_stats->hitgroup[HITGROUP_LEFTLEG] );
	}
	else if (!strcmp(src,"b_rightleg")){
		sprintf(value, "%d", score.wpn_stats->hitgroup[HITGROUP_RIGHTLEG] );
	}
	else if (!strcmp(src,"playersnum")){ // number of players in game
		int playersnum = 0;
		player_t *pTemp;
		for(int i = 1; i <= gpGlobals->maxClients; ++i){
			pTemp = GET_PLAYER_POINTER_I(i);
			if (pTemp->ingame) ++playersnum;
		}
		sprintf(value, "%d", playersnum );
	}
	else if (*src == '@'){ // LOCALINFO
		return LOCALINFO((char*)(src+1));
	}
	else { // CVAR
		return (char*)CVAR_GET_STRING(src);
	}

	return value;
}

char* UTIL_FillWithVars(const char* src)
{
	static char message[MAX_DATA_LEN];
	int len = 0;
	if (src){
begin1:
		while (*src){
			if (*src == '{'){
				++src;
				bool bit_check = false;
				static char cvar_value[MAX_CVAR_LEN]; int value_len = 0;
				static char cvar_name[MAX_CVAR_LEN]; int cvar_len = 0;
				static char state1[MAX_BUF_LEN]; int st1_len = 0;
				static char state2[MAX_BUF_LEN]; int st2_len = 0;
				while (*src && *src != '}') {
					if (*src == '&'){
						++src;
						while (*src && *src != '?')
							cvar_value[value_len++] = *src++; /*get name of cvar*/
						cvar_value[value_len] = 0;
						bit_check = true;
					}
					if (*src == '?'){
						++src;
						while (*src) {
							if (*src == ':' && *(src-1) != '\\'){
								++src;	
								while (*src){
									if (*src == '}'){
										++src;
										goto end1;
									}
									state2[st2_len++] = *src++; /*get msg on false*/
								}
							}		
							state1[st1_len++] = *src++; /*get msg on true*/
						}
					}
					cvar_name[cvar_len++] = *src++; /*get name of cvar*/
				}
				if (*src == 0){
					goto end_f;
				}
				else {
					++src;
				}
end1:
				cvar_name[cvar_len] = 0;
				state1[st1_len] = 0;
				state2[st2_len] = 0;
				const char* sCvar = GetAskedValue(cvar_name);
				if (st1_len == 0 && st2_len == 0){/*no cases, just plain var - { x } */
					while (*sCvar){
						message[len++] = *sCvar++;
					}
				}
				else if (IsANumber(sCvar)){
					float fCvar = atof(sCvar);
					if (bit_check ? ((int)fCvar&atoi(cvar_value)) : fCvar ){
						goto state1;
					}
					else{  /*fill info with false case*/
						const char* pSt2 = state2;
						if (!strcmp(state2,"#skip!")){
							len = 0; //SPECIAL FUNCTION!!!!
							goto end_f;
						}
						while (*pSt2){
							if (*pSt2=='\\'){
								//if (*(pSt2+1)==':')
								//	message[len++] = ':';
								if (*(pSt2+1)=='\'')
									message[len++] = '\"';
								//else if (*(pSt2+1)=='$')
								//	message[len++] = '$';
								else
									message[len++] = *(pSt2+1);
								pSt2+=2;
								continue;
							}
							message[len++] = *pSt2++;
						}
					}
				}
				else{
state1: /*fill info with true case*/
					const char* pSt1 = state1;
					if (!strcmp(state1,"#skip!")){
						len = 0; //SPECIAL FUNCTION!!!!
						goto end_f;
					}
					while (*pSt1){
						if (*pSt1 == '$') {
							while (*sCvar){
								message[len++] = *sCvar++;
							}
							++pSt1;
							continue;
						}
						else if (*pSt1 == '\\'){
							//if (*(pSt1+1)=='$')
							//	message[len++] = '$';
							if (*(pSt1+1)=='\'')
								message[len++] = '\"';
							//else if (*(pSt1+1)==':')
							//	message[len++] = ':';
							else
								message[len++] = *(pSt1+1);
							pSt1+=2;
							continue;
						}
						else if (*pSt1=='\\'&&*(pSt1+1)==':'){
							message[len++] = ':';
							pSt1+=2;
							continue;
						}
						message[len++] = *pSt1++;
					}
				}
				goto begin1;
			}/*end of { x ? a : b } */
			else if (*src == '\\')	{
				switch(*(src + 1)){
				case '\\':
					message[len++] = *(src+1);
					message[len++] = *(src+2);
					++src;
					break;
				case 'n':
					message[len++] = '\n';
					break;
				case '\'':
					message[len++] = '\"';
					break;
				case '{':
					message[len++] = '{';
					break;
				case '}':
					message[len++] = '}';
					break;
				}
				src+=2;
				continue;
			}

			message[len++] = *src++;
		}
	}
end_f:
	if (len){
		message[len++] = '\n'; //looks very strange but in this plugin every call for this fun. ends with \n
	}
	message[len] = 0;
	return message;
}

#define MAX_PRINT_MSG 190

void UTIL_ClientPrint( edict_t *pEntity, int msg_dest,  char *fmt, ... )
{	
	va_list			argptr;
	static char		msg_name[512];
	
	va_start ( argptr, fmt );
	vsprintf ( msg_name, fmt, argptr );
	va_end   ( argptr );

	MESSAGE_BEGIN( MSG_ONE, gmsgTextMsg, NULL, pEntity );
	WRITE_BYTE( msg_dest );

	static char message[MAX_PRINT_MSG+2];
	if ( strlen( msg_name ) < MAX_PRINT_MSG ) {
		strcpy( message, msg_name );
	}
	else {
		strncpy( message, msg_name, MAX_PRINT_MSG );
		message[MAX_PRINT_MSG] = 0;		// strncpy doesn't always append the null terminator
	}

	WRITE_STRING( message );
	MESSAGE_END();
}

void UTIL_ClientPrintMsgAll( int msg_dest,  char *fmt, ... )
{	
	va_list			argptr;
	static char		string[512];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	MESSAGE_BEGIN( MSG_ALL, gmsgTextMsg );
		WRITE_BYTE( msg_dest );

	char message[MAX_PRINT_MSG+2];
	if ( strlen( string ) < MAX_PRINT_MSG ) {
		strcpy( message, string );
	}
	else {
		strncpy( message, string, MAX_PRINT_MSG );
		message[MAX_PRINT_MSG] = 0;		// strncpy doesn't always append the null terminator
	}

		WRITE_STRING( message );
	MESSAGE_END();
}

#define MAX_MENU_CHUNK 176
int		menu_keys[] = {1,2,4,8,16,32,64,128,256,512};

void UTIL_ShowMenu( player_t *pPlayer, int slots, int displaytime, char *aMenuList )
{
	char chunk[MAX_MENU_CHUNK+1];
	char *pMenuList = aMenuList;
	int len = 0;
	//save bit keys for menu
	pPlayer->menu_keys = 0;
	for (int i = 0; i < 10;++i)
		if (slots & menu_keys[i]) 
			pPlayer->menu_keys |= (1<<(i+1));
	while ( pMenuList && *pMenuList ) {
		if ( strlen( pMenuList ) < MAX_MENU_CHUNK ){
			strcpy( chunk, pMenuList );
		}
		else {
			strncpy( chunk, pMenuList, MAX_MENU_CHUNK );
			chunk[MAX_MENU_CHUNK] = 0;
		}
		len += strlen( chunk );//Move text to next chunk
		pMenuList = aMenuList + len;
		MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer->pEdict );	
			WRITE_SHORT( slots );
			WRITE_CHAR( displaytime );
			WRITE_BYTE(*pMenuList ? TRUE : FALSE); //Need more menu?
			WRITE_STRING(chunk);
		MESSAGE_END();
	}
}

void GetPlayersList(player_t *pPlayer)
{
	pPlayer->player_num = 0;
	for (int i=1;i<=gpGlobals->maxClients;++i)
		if (players[i].ingame)
			pPlayer->pList[pPlayer->player_num++] = &players[i];
}

void StatsMeMenu(player_t *pPlayer, int state)
{
	if (state < 0){ //we have pressed exit
		pPlayer->start_action = MENU_IDLE;
		return;
	}

	int list_end, list_begin, pages_num = 0, pos_num = 0, index_key = 0, keys = 0;
	char textmenu[512]; int len = 0;

	for(menu_t*s=sm_menu;s;s=s->next)
		++pos_num;
	pages_num = (pos_num / 8) + ((pos_num % 8)?1:0);

	if (score.mod_id == MOD_CSTRIKE)
		len+=sprintf(textmenu, "\\yStatsMe Menu \\R%d/%d\n\\w\n", state + 1, pages_num); //Print header
	else
		len+=sprintf(textmenu, "StatsMe Menu %d/%d\n\n", state + 1, pages_num); //Print header

	pPlayer->menu_state = state; //set position in menu (which page)
	list_begin = (state*8); //get begin of list
	list_end = (pos_num > list_begin + 8) ? (list_begin + 8) : pos_num;
	
	menu_t*a=sm_menu;
	for(int c = 0;c<list_begin;c++)
		a=a->next;

	for (int i=list_begin;i<list_end;++i) {
		if (a->cmd && a->cmd[0] == ' ' && !a->cmd[1]){
			len+=sprintf(&textmenu[len], (score.mod_id == MOD_CSTRIKE)?
				(char*)"\\d    %s\\w":(char*)"    %s", UTIL_FillWithVars(a->name) );
			++index_key;
		}
		else {
			len+=sprintf(&textmenu[len], (score.mod_id == MOD_CSTRIKE)?
				(char*)"\\w%d.  %s":(char*)"%d.  %s", index_key+1, UTIL_FillWithVars(a->name) );
			keys += menu_keys[index_key++]; //Add proper key to menu keys
		}
		a = a->next;
	}
	if (list_end < pos_num){
		len+=sprintf(&textmenu[len],(score.mod_id == MOD_CSTRIKE)?
			(char*)"\n\\w9.  More...":(char*)"\n9.  More...");
		keys += menu_keys[8];
	}
	strcat(&textmenu[len], (score.mod_id == MOD_CSTRIKE)?((state)?("\n\\w0.  Back"):("\n\\w0.  Exit")):
			((state)?("\n0.  Back"):("\n0.  Exit")));
	keys+=menu_keys[9];
	UTIL_ShowMenu(pPlayer, keys, -1,textmenu);
	pPlayer->start_action = STATSME_MENU;
}

void StatsMenu(player_t *pPlayer, int state)
{
	if (state < 0){ //we have pressed exit
		pPlayer->start_action = MENU_IDLE;
		return;
	}

	GetPlayersList(pPlayer); //Check if there is someone to kick
	int list_end, list_begin, pages_num = 0, index_key = 0, keys = 0;
	char textmenu[512]; int len = 0;
	while ((pages_num*8) < pPlayer->player_num) //get number of all pages
		++pages_num;
	if (score.mod_id == MOD_CSTRIKE)
		len+=sprintf(textmenu, "\\yStats Menu \\R%d/%d\n\\w\n", state + 1, pages_num); //Print header
	else
		len+=sprintf(textmenu, "Stats Menu %d/%d\n\n", state + 1, pages_num); //Print header
	pPlayer->menu_state = state; //set position in menu (which page)
	list_begin = (state*8); //get begin of list
	//check if this is a last page or we are at the middle
	list_end = (pPlayer->player_num > list_begin + 8) ? (list_begin + 8) : pPlayer->player_num;
	for (int i=list_begin;i<list_end;++i) {
		len+=sprintf(&textmenu[len], "%d.  %s\n", index_key+1, STRING(pPlayer->pList[i]->pEdict->v.netname));
		keys += menu_keys[index_key++]; //Add proper key to menu keys
	}
	if (list_end < pPlayer->player_num){
		len+=sprintf(&textmenu[len],"\n9.  More...");
		keys += menu_keys[8];
	}
	strcat(&textmenu[len], (state)?("\n0.  Back"):("\n0.  Exit"));
	keys+=menu_keys[9];
	UTIL_ShowMenu(pPlayer, keys, -1,textmenu);
	pPlayer->start_action = STATS_MENU;
}
